import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:json_annotation/json_annotation.dart';

part 'pokemon_list_response.g.dart';
part 'pokemon_list_response.freezed.dart';

@JsonSerializable()
@freezed
class PokemonListResponse with _$PokemonListResponse {
  factory PokemonListResponse(int count, String next, String? previous,
          {@Default([]) List<PokemonListResponseItem> results}) =
      _PokemonListResponse;

  factory PokemonListResponse.fromJson(Map<String, dynamic> json) =>
      _$PokemonListResponseFromJson(json);
}

@JsonSerializable()
@freezed
class PokemonListResponseItem with _$PokemonListResponseItem {
  factory PokemonListResponseItem(String name, String url) = _PokemonListResponseItem;

  factory PokemonListResponseItem.fromJson(Map<String, dynamic> json) =>
      _$PokemonListResponseItemFromJson(json);
}
